/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};

var mystream;
var mywriter;

var myTextEnc = new TextEncoder();

var DataArray= [];
var DataChangeArray= [];
    
var myFileText = "";

var startTime;

var saveStart = function(filename) {
    //if (!filename) filename = 'dualRayData.txt';
    if (!filename) filename = logfile_textbox.value;
    mystream = streamSaver.createWriteStream(filename);
    EncodedFileText = "";
    var today = new Date().toString().replace(/[^\w]/g, '');
    myTextEnc = new TextEncoder();
    //myFileText = "DualRay Capture," + Date().toString() + '\n';
    mywriter = mystream.getWriter();
    var encodedData = myTextEnc.encode("DualRay Capture\n");
    mywriter.write(encodedData);
    startTime = Date.now();
    encodedData = myTextEnc.encode(Date().toString() + '\n');
    mywriter.write(encodedData);
    // Initialize the data array
    if (ti_widget_labelIndex.label == 1) {
        encodedData = myTextEnc.encode("TimeStamp(ms),Dark IR,Light IR,Diff IR,Dark blue,Light blue,Diff blue,Current blue,Current IR,CO,Int Temp,Ext Temp\n");
        mywriter.write(encodedData);
        DataArray[0] = Plot_IR.value_0;
        DataArray[1] = Plot_IR.value_1;
        DataArray[2] = Plot_refDelta.value_0;
        DataArray[3] = Plot_Blue.value_0;
        DataArray[4] = Plot_Blue.value_1;
        DataArray[5] = Plot_refDelta.value_1;
        DataArray[6] = TextBox_CurrentBlue.value;
        DataArray[7] = TextBox_CurrentRed.value;
        DataArray[8] = Gauge_CO.value;
        DataArray[9] = Gauge_intTemp.value;
        DataArray[10] = Gauge_extTemp.value;
    }
    for (i = 0; i < DataArray.length; i++) {
         DataChangeArray[i] = 0;
    }
    loggingStart_button.disabled = true;
    loggingStop_button.disabled = false;

    
};
var saveStop = function() {
    if (mywriter) {
        //mywriter.write(myTextEnc.encode(myFileText));
        mywriter.close();
        mywriter = null;
    }
    loggingStart_button.disabled = false;
    loggingStop_button.disabled = true;
};
var saveAbort = function() {
    if (mywriter){
        mywriter.abort('reason');
        mywriter = null;
    }
};

var saveData = function(data) {
    if (mywriter) {
        mywriter.write(data);
    }
};

var AddData = function(pos, value) {
    DataArray[pos] = value;
    DataChangeArray[pos] += 1;
    var isAllData = DataChangeArray.every(item => item === 1);
    var isSomeTwo = DataChangeArray.some(item => item === 2);
    if (isAllData || isSomeTwo)
    {
        const millis = Date.now() - startTime;
        var DataString = millis.toString() + ',';
        for (i = 0; i < DataArray.length; i++) {
            DataString += DataArray[i].toString();
            DataString += ',';
        }
        var encodedData = myTextEnc.encode(DataString + '\n');
        mywriter.write(encodedData);
        for (i = 0; i < DataArray.length; i++) {
            DataChangeArray[i] = 0;
        }
    }
   //myFileText += "PDMeas," + value.toString() + ',';
   //var encodedData = myTextEnc.encode("PDMeas," + value.toString() + ',');
   //EncodedFileText += encodedData;
   //console.log(encodedData);
   //mywriter.write(encodedData);
};



//https://developer.mozilla.org/en-US/docs/Web/API/Window/beforeunload_event
window.addEventListener('beforeunload', (event) => {
  // The beforeunload event is triggered when hyperlink is clicked,
  //   or when the browser tab (ie gc app here) is closed.
  // So, when user click saveStart, this handler is also called (due to hyperlink)
  // If you have to use this event handler, you need to figure whether you should 
  // or should not call saveAbort.
  //saveAbort();
});
window.addEventListener('unload', (event) => {
    saveAbort(); // avoid file being hang-around in file sytstem.
});

/*
*  Boilerplate code for creating computed data bindings
*/
document.addEventListener('gc-databind-ready', function() 
{
    /* 
	*   Add custom computed value databindings here, using the following method:
	*
    *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
	*
	*   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
	*   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
    */
	
	// For example, a simple computed values based on simple expression
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");
	
	// Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });
	
	// Event 1 to n bindings
	/* 
    gc.databind.registry.bind('widget.date.value', 
        // dependant bindings needed in order to compute the date, in name/value pairs.
        {
            weekday: 'widget.dayOfWeek.selectedText',
            day: 'widget.dayOfMonth.value',
            month: 'widget.month.selectedText',
            year: 'widget.year.value'
        }, 
        // getter for date computation
        function(values) 
        {
            // compute and return the string value to bind to the widget with id 'date'
            return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
        }
    ); 
	*/
	
	/* Data from Device is expected in the following format:
	    Measurement:
	        dR: dark Red
	        lR: light Red
	        fR: delta Red
	        dB: dark Blue
	        lB: light Blue
	        fB: delta Blue
	        iB: Current Blue
	        iR: Current Red
	        CO: CO measurement
	  Temperature:
	        tempC: internal Temp
	        etempC: external Temp
	  It will be stored as: 
	  PDMeas,dR,lR,fR,dB,lB,fB
	  Curr,iB,iR
	  CO,CO
	  Temp,tempC,etempC
	*/
	// **************** Log the LED measurement *****************
	//      Format: PDMeas,dR,lR,fR,dB,lB,fB
	// Start Line, "PDMeas", Dark RED
    gc.databind.registry.bind('widget.Plot_IR.value_0',"dR", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(0, value);
                    //DataArray[0] = value.toString();
                    //DataChangeArray[0] += 1;
                    //var isAllData = DataChangeArray.every(item => item === 1);
                    //var isSomeTwo = arr.some(item => item > 1);
                   //myFileText += "PDMeas," + value.toString() + ',';
                   //var encodedData = myTextEnc.encode("PDMeas," + value.toString() + ',');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 

    // Light RED
    gc.databind.registry.bind('widget.Plot_IR.value_1',"lR", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(1, value);
                    //DataArray[1] = value.toString();
                    //myFileText += (value.toString() + ',');
                   //var encodedData = myTextEnc.encode(value.toString() + ',');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 
    
    // Delta RED
    gc.databind.registry.bind('widget.Plot_refDelta.value_0',"fR", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(2, value);
                   // myFileText += (value.toString() + ',');
                   //var encodedData = myTextEnc.encode(value.toString() + ',');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 
    
    // Dark Blue
    gc.databind.registry.bind('widget.Plot_Blue.value_0',"dB", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(3, value);
                    //myFileText += (value.toString() + ',');
                   //var encodedData = myTextEnc.encode(value.toString() + ',');
                   ///EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 

    // Light Blue
    gc.databind.registry.bind('widget.Plot_Blue.value_1',"lB", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(4, value);
                     //myFileText += (value.toString() + ',');
                   //var encodedData = myTextEnc.encode(value.toString() + ',');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 
    
    // Delta Blue , end line
    gc.databind.registry.bind('widget.Plot_refDelta.value_1',"fB", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(5, value);
                     //myFileText += (value.toString() + '\n');
                   //var encodedData = myTextEnc.encode(value.toString() + '\n');
                   //EncodedFileText += encodedData;
                   ///console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 

    // **************** Log the Current measurement *****************
	//      Format: Curr,iB,iR
	// Start Line, "Curr", Blue Current
    gc.databind.registry.bind('widget.TextBox_CurrentBlue.value',"iB", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(6, value);
                    //myFileText += ("Curr," + value.toString() + ',');
                   //var encodedData = myTextEnc.encode("Curr," + value.toString() + ',');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 
	// Red Current, end line
    gc.databind.registry.bind('widget.TextBox_CurrentRed.value',"iR", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(7, value);
                    //myFileText += (value.toString() + '\n');
                   //var encodedData = myTextEnc.encode(value.toString() + '\n');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 
    
    // **************** Log the CO measurement *****************
	//      Format: CO,CO
	// Start Line, "CO", CO measurement, end Line
    gc.databind.registry.bind('widget.Gauge_CO.value',"CO", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(8, value);
                    //myFileText += ("CO," + value.toString() + '\n');
                   //var encodedData = myTextEnc.encode("CO," + value.toString() + '\n');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 
    
    // **************** Log the Temperature measurement *****************
	//      Format: Temp,tempC,etempC
	// Start Line, "Temp", Internal Temperature
    gc.databind.registry.bind('widget.Gauge_intTemp.value',"tempC", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(9, value);
                    //myFileText += ("Temp," + value.toString() + ',');
                   //var encodedData = myTextEnc.encode("Temp," + value.toString() + ',');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 
	// external temperature, end line
    gc.databind.registry.bind('widget.Gauge_extTemp.value',"etempC", 
        function(value) 
        {
            if (mywriter) {
                if (ti_widget_labelIndex.label == 1) {
                    AddData(10, value);
                    //myFileText += (value.toString() + '\n');
                   //var encodedData = myTextEnc.encode(value.toString() + '\n');
                   //EncodedFileText += encodedData;
                   //console.log(encodedData);
                   //mywriter.write(encodedData);
                }
            }
            return value;
        }
    ); 

});

/*
*  Boilerplate code for creating custom actions
*/
document.addEventListener('gc-nav-ready', function() 
{
    /* 
	*   Add custom actions for menu items using the following api:
	*
    *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
	*
	*   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
	*   param runable - function that performs the custom action.
	*   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
	*   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
    */
	
	// For example,
	// gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });
	
	// Alternatively, to programmatically disable a menu action at any time use:
	// gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction'); 
});

/*
*  Boilerplate code for working with components in the application gist
*/
/*

var initComplete = false;
var templateObj;

// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
	templateObj.addEventListener('dom-change',function(){
	    if (initComplete) return;
	    this.async(function(){
    	    initComplete = true;
    	    console.log("Application template has been stamped.");
  	        // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
  	        // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId

        },1);

	});
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded',init.bind(this))
}
*/

